diff --git a/src/base/emu-i386/simx86/codegen-x86.c b/src/base/emu-i386/simx86/codegen-x86.c
index f08ecfc33c..56790af4ab 100644
--- a/src/base/emu-i386/simx86/codegen-x86.c
+++ b/src/base/emu-i386/simx86/codegen-x86.c
@@ -3325,6 +3325,7 @@ unsigned int Exec_x86_fast(TNode *G)
 	unsigned char *ecpu = CPUOFFS(0);
 	unsigned long flg = Exec_x86_pre(ecpu);
 	unsigned int ePC, mem_ref;
+	unsigned mode = G->mode;
 
 	do {
 		ePC = Exec_x86_asm(mem_ref, flg, ecpu, G->addr);
@@ -3340,7 +3341,7 @@ unsigned int Exec_x86_fast(TNode *G)
 			break;
 		}
 	} while (!TheCPU.err && (G=FindTree(ePC)) &&
-		 G->cs == LONG_CS && !(G->flags & (F_FPOP|F_INHI)));
+		 GoodNode(G, mode) && !(G->flags & (F_FPOP|F_INHI)));
 
 	Exec_x86_post(flg, mem_ref);
 	TheCPU.sigalrm_pending = 0;
diff --git a/src/base/emu-i386/simx86/codegen-x86.h b/src/base/emu-i386/simx86/codegen-x86.h
index d0ecc28ae5..b6deda7b47 100644
--- a/src/base/emu-i386/simx86/codegen-x86.h
+++ b/src/base/emu-i386/simx86/codegen-x86.h
@@ -124,4 +124,21 @@ void NodeUnlinker(TNode *G);
 
 extern unsigned char TailCode[];
 
+static __inline__ int GoodNode(TNode *G, int mode)
+{
+	if (G->cs != LONG_CS) {
+		/* CS mismatch can confuse relative jump/call */
+		e_printf("cs mismatch at %08x: old=%x new=%x\n",
+					G->key, G->cs, LONG_CS);
+		return 0;
+	}
+	if (G->mode != mode) {
+		/* mode mismatch can be 32/16 or MREALA */
+		e_printf("mode mismatch at %08x: old=%x new=%x\n",
+					G->key, G->mode, mode);
+		return 0;
+	}
+	return 1;
+}
+
 #endif
diff --git a/src/base/emu-i386/simx86/interp.c b/src/base/emu-i386/simx86/interp.c
index b0fb536753..ec3428a85b 100644
--- a/src/base/emu-i386/simx86/interp.c
+++ b/src/base/emu-i386/simx86/interp.c
@@ -362,20 +362,7 @@ static unsigned int FindExecCode(unsigned int PC)
 	 */
 	while (!(CEmuStat & (CeS_TRAP|CeS_DRTRAP|CeS_SIGPEND)) &&
 	       (G=FindTree(PC))) {
-		int inv = 0;
-		if (G->cs != LONG_CS) {
-			/* CS mismatch can confuse relative jump/call */
-			e_printf("cs mismatch at %08x: old=%x new=%x\n",
-					PC, G->cs, LONG_CS);
-			inv++;
-		}
-		if (G->mode != mode) {
-			/* mode mismatch can be 32/16 or MREALA */
-			e_printf("mode mismatch at %08x: old=%x new=%x\n",
-					PC, G->mode, mode);
-			inv++;
-		}
-		if (inv) {
+		if (!GoodNode(G, mode)) {
 			InvalidateNodeRange(G->seqbase, G->seqlen, NULL);
 			return PC;
 		}
@@ -407,7 +394,7 @@ static unsigned int FindExecCode(unsigned int PC)
 		/* try fast inner loop if nothing special is going on */
 		if (!(CEmuStat & (CeS_INHI|CeS_MOVSS)) &&
 		    !debug_level('e') && eTimeCorrect < 0 &&
-		    G->cs == LONG_CS && !(G->flags & (F_FPOP|F_INHI)))
+		    GoodNode(G, mode) && !(G->flags & (F_FPOP|F_INHI)))
 			PC = Exec_x86_fast(G);
 		else
 #endif
